PropertyAccessor (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.expression

## Interface PropertyAccessor

- All Known Implementing Classes:
    BeanExpressionContextAccessor, BeanFactoryAccessor, EnvironmentAccessor, MapAccessor, ReflectivePropertyAccessor

      public interface PropertyAccessor

  A property accessor is able to read (and possibly write) to object properties. The interface places no restrictions and so implementors are free to access properties directly as fields or through getters or in any other way they see as appropriate. A resolver can optionally specify an array of target classes for which it should be called - but if it returns null from getSpecificTargetClasses() then it will be called for all property references and given a chance to determine if it can read or write them. Property resolvers are considered to be ordered and each will be called in turn. The only rule that affects the call order is that any naming the target class directly in getSpecifiedTargetClasses() will be called first, before the general resolvers.
  Since:
    3.0
  Author:
    Andy Clement

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canRead(EvaluationContext context, Object target, String name)` Called to determine if a resolver instance is able to access a specified property on a specified target object.
    `boolean` | `canWrite(EvaluationContext context, Object target, String name)` Called to determine if a resolver instance is able to write to a specified property on a specified target object.
    `Class[]` | `getSpecificTargetClasses()` Return an array of classes for which this resolver should be called.
    `TypedValue` | `read(EvaluationContext context, Object target, String name)` Called to read a property from a specified target object
    `void` | `write(EvaluationContext context, Object target, String name, Object newValue)` Called to write to a property on a specified target object.

- - ### Method Detail

    - #### getSpecificTargetClasses

          Class[] getSpecificTargetClasses()

      Return an array of classes for which this resolver should be called. Returning null indicates this is a general resolver that can be called in an attempt to resolve a property on any type.
      Returns:
        an array of classes that this resolver is suitable for (or null if a general resolver)

    - #### canRead

          boolean canRead(EvaluationContext context,
                        Object target,
                        String name)
                          throws AccessException

      Called to determine if a resolver instance is able to access a specified property on a specified target object.
      Parameters:
        `context` - the evaluation context in which the access is being attempted
        `target` - the target object upon which the property is being accessed
        `name` - the name of the property being accessed
      Returns:
        true if this resolver is able to read the property
      Throws:
        `AccessException` - if there is any problem determining whether the property can be read

    - #### read

          TypedValue read(EvaluationContext context,
                        Object target,
                        String name)
                          throws AccessException

      Called to read a property from a specified target object
      Parameters:
        `context` - the evaluation context in which the access is being attempted
        `target` - the target object upon which the property is being accessed
        `name` - the name of the property being accessed
      Returns:
        a TypedValue object wrapping the property value read and a type descriptor for it
      Throws:
        `AccessException` - if there is any problem accessing the property value

    - #### canWrite

          boolean canWrite(EvaluationContext context,
                         Object target,
                         String name)
                           throws AccessException

      Called to determine if a resolver instance is able to write to a specified property on a specified target object.
      Parameters:
        `context` - the evaluation context in which the access is being attempted
        `target` - the target object upon which the property is being accessed
        `name` - the name of the property being accessed
      Returns:
        true if this resolver is able to write to the property
      Throws:
        `AccessException` - if there is any problem determining whether the property can be written to

    - #### write

          void write(EvaluationContext context,
                   Object target,
                   String name,
                   Object newValue)
                     throws AccessException

      Called to write to a property on a specified target object. Should only succeed if canWrite() also returns true.
      Parameters:
        `context` - the evaluation context in which the access is being attempted
        `target` - the target object upon which the property is being accessed
        `name` - the name of the property being accessed
        `newValue` - the new value for the property
      Throws:
        `AccessException` - if there is any problem writing to the property value